UNIT Clocks;

INTERFACE
USES
  Globals;

TYPE
   Mode = (Start, Elapsed);

FUNCTION Clock(Button : Mode) : Word64;
{-- returns time since start, in seconds }

IMPLEMENTATION
USES
  SysUtils;

VAR
  StartTime,
  StopTime  : Word64;
  Delta     : Int64;


FUNCTION Clock(Button : Mode) : Word64;
{-- in seconds }
BEGIN
  IF Button = Start THEN
    BEGIN
      StartTime := GetTickCount64;
      Clock     := 0;
    END
  ELSE  {-- elapsed time }
    BEGIN
      StopTime := GetTickCount64;
      Delta := Int64(StopTime - StartTime);
      IF Delta < 0 THEN  {-- roll over }
        Clock := (18446744073709551615 - StartTime) + StopTime
      ELSE
        Clock := (StopTime - StartTime) DIV 1000; {-- time alapsed in seconds }
    END;
END;


BEGIN
END.
